#!/bin/sh

[ -z "${buildcpd}" ] && [ -f /usr/bin/build-dixi-classpath-directory ] \
	&& buildcpd=/usr/bin/build-dixi-classpath-directory
[ -z "${buildcpd}" ] \
	&& buildcpd=./Support/runscript/maintenance/build-dixi-classpath-directory
[ -z "$dixi_run_cmd" ] && dixi_run_cmd=`basename "$0"`
START_DIR="$(pwd)"

[ -z "$AEM_HOME" ] && AEM_HOME=/usr/share/dixi
[ -z "$SRDS_LIBS" ] && SRDS_LIBS=/usr/share/srds/libs
XATI_LOG4J_PROPERTY="${AEM_HOME}/log4j_xati.properties"
XOSD_LOG4J_PROPERTY="${AEM_HOME}/log4j.properties"
XOSD_CONFIG=/etc/xos/config/XOSdConfig.conf
VNODES_CONFIG=/etc/xos/config/XOSdVNodes.conf
CPCLASSES_JARS=`${buildcpd} $AEM_HOME`":$CLASSPATH"
CONFIGPATH=/etc/xos/config/dixi/
PRINTUSAGE="n"
OWLOG_PROPS="-Djava.util.logging.config.file=/etc/xos/config/OW/owlogging.properties"
ROOT_SCHEMA_PATH="-DpathToRootSchemas=/usr/share/dixi/XMLExtractor/Schemas/"
# something to recognise the xosd by
XOSD_SIGN="xosd_daemon"


JNIS=`find $AEM_HOME -type d -iname "JNI"`
for N in $JNIS
do
	CPJNIS=$CPJNIS":"$N
done

cd ${AEM_HOME}

case "$dixi_run_cmd" in

	rca_apply)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA a
	;;

	rca_confirm)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA c $*
	;;

	rca_update)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA e $*
	;;

	rca_remove)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA u $*
	;;

	rca_unregister)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA u $*
	;;

	add_resource_to_vo)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA avo $*
	;;

	request_vo_certificate)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA cvo $*
	;;

	rca_info)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA d
	;;

	rca_list_pending)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA lp
	;;

	rca_list_registered)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA lr
	;;

	rca_request)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA r
	;;
	
	rca_node_descriptor)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA i
	;;
	
	rca_primary)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -RCA s "$@"
	;;
	
	xmon)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -xmon "$@"
	;;
	
	xaudit)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -xaudit "$@"
	;;

	vops)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -VOPS $*
	;;

	xconsole_dixi)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	cd "${START_DIR}"
	exec java -cp $CONFIGPATH:$CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XConsole $*
	;;

	xosdkill)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	echo Killing XOSd. This script is likely to hang, so 
	echo Ctrl+C it once the XOSd is finished.
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest -xosd q
	;;

	xosd)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	echo Executing XOS Daemon...
	java -cp $XOSD_SIGN:$CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XOSD_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS ${OWLOG_PROPS} ${ROOT_SCHEMA_PATH} eu.xtreemos.xosd.XOSd -r ${AEM_HOME} $* <&- 2>&1 &
	;;

	xosd_profile)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	java -Xrunjprofiler -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XOSD_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS ${OWLOG_PROPS} ${ROOT_SCHEMA_PATH} eu.xtreemos.xosd.XOSd -r ${AEM_HOME} $* 
	;;

	dixi_test)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CONFIGPATH:$CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest $*
	;;

	dixi_diag)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	exec java -cp $CONFIGPATH:$CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.DIXIDiagnose $*
	;;

	xreservation)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	cd "${START_DIR}"
	exec java -cp $CONFIGPATH:$CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS ${ROOT_SCHEMA_PATH} eu.xtreemos.xati.test.XReservation $*
	;;

	rca_vo)
	if [ "$#" -lt "1" ]
	then
		PRINTUSAGE="y"
	else
		PARAMS="-RCA"
	
		if [ "$1" = "a" -a  "$#" -lt "2" -o "$1" = "r"  -a  "$#" -lt "2" ]
		then
			PRINTUSAGE="y"
		else
			if [ "$1" = "a" ]
			then
				PARAMS="${PARAMS} +vo $2"
			elif [ "$1" = "r" ]
			then
				PARAMS="${PARAMS} -vo $2"
			elif [ "$1" = "l" ]
			then
				PARAMS="${PARAMS} lvo"
			else
				PRINTUSAGE="y"
			fi
		fi
	fi
	
	if [ "${PRINTUSAGE}" = "y" ]
	then
		echo "${dixi_run_cmd} action [VOID]"
		echo 
		echo "Manipulate the membership of the RCA in the VOs."
		echo 
		echo " action:"
		echo "   a   add the RCA to the VO (requires VOID)"
		echo "   r   remove the RCA from the VO (requires VOID)"
		echo "   l   list the VOs the RCA is currently a member of"
		echo 
		echo  "VOID: the ID of the VO"
		echo
	else
		CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
		exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest $PARAMS
	fi
	;;

	rca_resource_vo)
	if [ "$#" -lt "2" ]
	then
		PRINTUSAGE="y"
	else
		PARAMS="-RCA"
		
		if [ "$1" = "a" ]
		then
			PARAMS="${PARAMS} avo $2 $3"
		elif [ "$1" = "r" ]
		then
			PARAMS="${PARAMS} rvo $2 $3"
		elif [ "$1" = "c" ]
		then
			PARAMS="${PARAMS} cvo $2 $3"
		else
			PRINTUSAGE="y"
		fi
	fi
	
	if [ "${PRINTUSAGE}" = "y" ]
	then
		echo "${dixi_run_cmd} ( a | c | r ) VOID [ nodeaddress ] "
		echo 
		echo "Manipulate the membership of the resouce in the VO. "
		echo 
		echo "Variants:"
		echo " ${dixi_run_cmd} a VOID [ nodeaddress ] "
		echo "   Add the resource to the VO. If nodeaddress is omitted, use this resource's address."
		echo 
		echo " ${dixi_run_cmd} c VOID"
		echo "   Request a certificate for the given VO."
		echo 
		echo " ${dixi_run_cmd} r VOID [ nodeaddress ] "
		echo "   Remove the resource from the VO. If nodeaddress is omitted, use this resource's address."
		echo 
		echo  "VOID: the ID of the VO"
		echo  "nodeaddress: the address of the node's access point (e.g. 192.168.2.15:60000)"
		echo
	else
		CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
		exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.XATItest $PARAMS
	fi
	;;

	validate-xml)
	CPJNIS="$CPJNIS:$AEM_HOME/libs/DIXI.jar"
	cd "${START_DIR}"
	exec java -cp $CONFIGPATH:$CPCLASSES:$CPCLASSES_JARS:. ${ROOT_SCHEMA_PATH} -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS eu.xtreemos.xati.test.ValidateXML $*
	;;
	
	dixi-junit-test)
	exec java -cp $CPCLASSES:$CPCLASSES_JARS:. -Dlog4j.configuration=file://${XATI_LOG4J_PROPERTY} -Djava.library.path=$CPJNIS -Dxosd.rootDirectory=${AEM_HOME} org.junit.runner.JUnitCore $*
	;;

esac
