#!/bin/bash

PID_VAL=$1
KILLTREE=/usr/share/dixi/killtree.sh
MYSELF="kill_dixi"

/usr/bin/xosdkill > /dev/null 2> /dev/null &
PID_XK=$!

sleep 10
if [ "`ps -A | grep $PID_XK | awk '{print $1}'`" = "$PID_XK" ]
then
	kill -9 $PID_XK
fi

${KILLTREE} ${PID_VAL}

# a brute force method that tries to kill possible remnants of xosd

DIXI_CONFIG=/etc/xos/config/XOSdConfig.conf

PORT_LINE=`cat $DIXI_CONFIG | grep xosdport`
RA_PORT_LINE=`cat $DIXI_CONFIG | grep rootaddress.port`

if [ ${#PORT_LINE} -eq 0 ]
then
	PORT_LINE=$RA_PORT_LINE
fi

PORT=`echo ${PORT_LINE//"="/" "} | awk '{print $2}'`
# remove any trailing comments
PORT=`echo ${PORT//"#"/" "} | awk '{print $1}'`

if [ ${#PORT} -eq 0 ]
then
	echo Port number not found in $DIXI_CONFIG
	return 1
fi

PORT_PATTERN=":$PORT[[:space:]]"

#try to kill all running instances of XOSd and its remnants

for pid in `netstat  -np |  awk '{print $4, $7}' | grep $PORT_PATTERN | sed 's/\// /' | awk '{print $2;}'`
do
	${KILLTREE} ${pid}
done

for pid in `ps aux | grep "xosd_daemon\|/usr/share/dixi" | grep -v "grep\|${MYSELF}" | awk '{print $2}'`
do
	${KILLTREE} ${pid} > /dev/null 2> /dev/null
done


